{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Sample player object using video generator as 12 bit mono dac
//  Piotr Kardasz pik33@o2.pl
//  Plays a 512 16-bit stereo samples buffer in endless loop
//  v.0.03 alpha - 20120706
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}


  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.

VAR

  long cog
  long buf[512]
  long bufnum



pub getbuf
return @buf

pub getbufnum
return bufnum


PUB start(left, right)

longfill(@buf,0,512)
bufptr:=@buf
stop
outputmask := |<left | |<right
cog:=1+cognew(@init, @bufnum)
return cog
  
PUB stop

if cog>0
  cogstop(cog-1)
cog := 0
  

DAT
                        org     0

init                    mov     dira,outputMask
                        mov     ctra,#0
                        movi    ctra,#%0_00001_111         'pll div 1
                        mov     frqa,frqa_val
                        mov     vscl,vscl_val              'init video generator
                        mov     vcfg,vcfg_val
                        mov     bufptr2,par

loop                    mov     ptr,bufptr
                        add     ptr,bufcnt         'pointer to next sample
                        rdword  lsample,ptr        'get left sample
                        add     lsample,offset     'convert to unsigned
                        add     ptr, #2
                        rdword  rsample,ptr
                        and     lsample,ffff
                        add     rsample,offset
                        and     rsample,ffff

                        add     bufcnt,#4
                        and     bufcnt,bufmask
                        wrlong  bufcnt,bufptr2

                        mov     t3,rsample
                        shr     t3,#4
                        and     t3,mask5

                        mov     t4,ffffffff
                        shr     t4,t3

                        mov     t1,rsample
                        shr     t1,#9
                        add     t1,#1
                        mov     t2,#129
                        sub     t2,t1
                        shl     t1,#5
                        shl     t2,#5
                        add     t2,vscl_val0
                        add     t1,vscl_val0

                        mov outa,zero

                        mov     vscl,t1
                        waitvid zero,zero

                        mov     vscl,vscl_val
                        waitvid ff00ff00,t4

                        mov     vscl,t2
                        waitvid ffffffff,ffffffff

                        mov vscl,vscl_val2
                        waitvid ffffffff,ffffffff

                        mov outa,ffffffff
                        jmp     #loop

outputmask        long    0


lsample    long 0
rsample    long 0
bufmask    long %0000_0000_0000_0000_0000_0111_1111_1111
ptr        long 0

bufptr     long 0
bufcnt     long 0
bufptr2    long 0

offset     long  $8000
ffff       long  %1111_1111_1111_1111
mask1      long  %0000_0000_0000_0000_0000_1100_0000_0000
mask5      long  31

ffffffff   long $ffffffff
ff00ff00   long $FF00FF00
zero       long 0
vscl_val   long $00001020       '
vscl_val0  long $00001000
t1         long 0
t2         long 0
t3         long 0
t4         long 0

vcfg_val   long $200002ff
frqa_val   long $29350000' $29350000
vscl_val2  long $00001200


                        fit     496

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}
